ProjOpenCoastS/urls.py
from django.conf.urls import url, include
from django.contrib import admin


urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url(r'^auth/', include('django_auth_oidc.urls')),
    url(r'^i18n/', include('django.conf.urls.i18n')),
    url(r'^', include('datamodel.urls')),
    url(r'^', include('front.urls')),
    url(r'^wizard/', include('wizard.urls')),
    url(r'^viewer/', include('viewer.urls')),
    url(r'^raster/', include('raster.urls')),
]

handler400 = 'front.views.handler400'
handler403 = 'front.views.handler403'
handler404 = 'front.views.handler404'
handler500 = 'front.views.handler500'

front/urls.py
from django.conf.urls import url
from .views import *
from django.views.generic import TemplateView

# TODO: when there is more than one app: point to views inside 'front' redirecting to the app selected by the user
from wizard.views import deployments, new_deploy, view_deploy, open_deploy, clone_deploy, deactivate_deploy, \
    reactivate_deploy, delete_deploy, extend_deploy, view_extend_deploys, get_file, print_deploy, \
    get_deploys, get_boundaries


urlpatterns = [
    url(r'^$', home, name='home'),
    url(r'^home/$', home, name='home'),
    url(r'^login/$', Login.as_view(), name='login'),
    url(r'^logout/$', logout_user, name='logout'),
    url(r'^register/$', register, name='register'),
    url(r'^register/confirm/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', register_confirm, name='register_confirm'),
    url(r'^profile/$', profile, name='profile'),
    url(r'^disclaimer/$', disclaimer, name='disclaimer'),

    url(r'^ratings/$', rate_service, name='rate_service'),

    url(r'^password/change/$', password_change, name='password_change'),
    url(r'^password/recover/$', password_recover, name='password_recover'),
    url(r'^password/recover/confirm/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', password_recover_confirm, name='password_recover_confirm'),

    url(r'^userprofile/activate/(?P<uidb64>[0-9A-Za-z_\-]+)/(?P<token>[0-9A-Za-z]{1,13}-[0-9A-Za-z]{1,20})/$', userprofile_activate, name='userprofile_activate'),
    url(r'^activate_user/(?P<username>[\w.%+-]+@[A-Za-z0-9.-]+\.[A-Za-z]{2,4})/$', activate_user, name='activate_user'),

    url(r'^login_egi/$', login_egi, name='login_egi'),
    url(r'^login_egi/complete/$', login_egi_complete, name='login_egi_complete'),
    url(r'^logout_egi/$', logout_egi, name='logout_egi'),

    url(r'^deployments/$', deployments, name='deployments'),
    url(r'^deployments/new/$', new_deploy, name='new_deploy'),
    url(r'^deployments/view/(?P<deploy_id>[0-9]+)/$', view_deploy, name='view_deploy'),
    url(r'^deployments/open/(?P<deploy_id>[0-9]+)/$', open_deploy, name='open_deploy'),
    url(r'^deployments/clone/(?P<deploy_id>[0-9]+)/$', clone_deploy, name='clone_deploy'),
    url(r'^deployments/deactivate/(?P<deploy_id>[0-9]+)/$', deactivate_deploy, name='deactivate_deploy'),
    url(r'^deployments/reactivate/(?P<deploy_id>[0-9]+)/$', reactivate_deploy, name='reactivate_deploy'),
    url(r'^deployments/delete/(?P<deploy_id>[0-9]+)/$', delete_deploy, name='delete_deploy'),
    url(r'^deployments/extend/$', extend_deploy, name='extend_deploy'),
    url(r'^deployments/view_extends/$', view_extend_deploys, name='view_extend_deploys'),
    url(r'^deployments/get_deploys/$', get_deploys, name='get_deploys'),

    url(r'^deployments/file/(?P<action>[[\w\-]+)/(?P<deploy_id>[0-9]+)/(?P<name>[[\w\-]+)/(?P<format>[[\w\-]+)/$', get_file, name='get_file'),
    url(r'^deployments/print/(?P<deploy_id>[0-9]+)/$', print_deploy, name='print_deploy'),
    url(r'^print/$', TemplateView.as_view(template_name="front/modal/printdeploy.html"), name='print'),

    url(r'^deployments/get_boundaries/(?P<deploy_id>[0-9]+)/$', get_boundaries, name='get_boundaries'),

    url(r'^download_file/(?P<file_cat>[[\w\-]+)/(?P<file_id>[0-9]+)/$', download_file, name='download_file'),

]

wizard/urls.py
from django.conf.urls import url
from .views import *
from django.conf.urls.static import static


urlpatterns = [
    url(r'^$', open_wizard, name='open_wizard'),

    url(r'^step1/$', templates[0]['function'], name='step1'),
    url(r'^step1/disclaimer/$', accept_disclaimer, name='accept_disclaimer'),
    url(r'^step1/restart/$', templates[0]['restart'], name='step1_restart'),
    url(r'^step1/get_run_periods/(?P<mv_pk>[0-9]+)/$', get_run_periods, name='get_run_periods'),
    url(r'^step2/$', templates[1]['function'], name='step2'),
    url(r'^step2/restart/$', templates[1]['restart'], name='step2_restart'),
    url(r'^step2/validate_file/$', validate_file, name='step2_validate_file'),
    url(r'^step3/$', templates[2]['function'], name='step3'),
    url(r'^step3/restart/$', templates[2]['restart'], name='step3_restart'),
    url(r'^step4/$', templates[3]['function'], name='step4'),
    url(r'^step4/restart/$', templates[3]['restart'], name='step4_restart'),
    url(r'^step5/$', templates[4]['function'], name='step5'),
    url(r'^step5/restart/$', templates[4]['restart'], name='step5_restart'),
    url(r'^step6/$', templates[5]['function'], name='step6'),
    url(r'^step6/restart/$', templates[5]['restart'], name='step6_restart'),
    url(r'^step7/$', templates[6]['function'], name='step7'),
    # url(r'^save_steps/$', save_steps, name='save_steps'),
    # url(r'^save_step/(?P<step>[0-9]+)/$', save_step, name='save_step'),
    url(r'^save_steps/(?P<step>[0-9]+)/$', save_steps, name='save_steps'),
]

wizard/models.py
from django.db import models

# Create your models here.

wizard/views.py
import os

from django.shortcuts import render, redirect, HttpResponse
from django.http import JsonResponse
from django.utils.translation import ugettext_lazy as _
from django.core.serializers import serialize

from django.contrib.auth.decorators import login_required
from django.contrib.sites.shortcuts import get_current_site
from django.forms import formset_factory

from .forms import *
from .tables import *
from .utils import *
from front.forms import ProfileRatingForm

from .forecast_models import schism_v540 as schism

from datetime import datetime

from front.decorators import deploy_permission
from front.utils import notify_extend_deploy

app_name = 'wizard'


@login_required(login_url='/login/')
def step_model(request):
    template, step, last_step, msg_str = templates[0]['path'], templates[0]['step'], 0, None
    step_forms, disclaimer = [], None
    step_name = 'step' + str(step)

    if 'last_step' in request.session:
        last_step = request.session['last_step']

    run_type = 'basic2d'

    if request.method == 'POST':
        model = ModelForm(request.POST, user=request.user)

        if step_name not in request.session:
            if 'run_type' in model.data:
                run_type = model.data['run_type']

            # Save model selection in session key
            request.session[step_name] = {'model_pk': str(model.data['model']), 'run_period_pk': model.data['run_period'], 'run_type': run_type}

        # Create wizard key for new deployment
        # New wizard - save a unique key as session key
        if not 'wizard_key' in request.session:
            request.session['wizard_key'] = str(string_concat('u', request.user.id, '_', datetime.strftime(timezone.now(), "%Y-%m-%d-%Hh%Mm%S_%fs")))

        # All went well - update LAST STEP
        if not last_step:
            request.session['last_step'] = step

        # Goto step2
        return redirect(templates[step]['name'])
    else:
        # Pass request
        if step_name in request.session:
            if 'run_type' in request.session[step_name]:
                run_type = request.session[step_name]['run_type']

            model = ModelForm(initial={'model': request.session[step_name]['model_pk'],
                                       'run_period': request.session[step_name]['run_period_pk'],
                                       'run_type': run_type}, user=request.user)
        else:
            model = ModelForm(user=request.user)

        step_forms.append(model)

    # Add disclaimer info if user hasn't accepted terms
    if not request.user.profile.read_disclaimer:
        disclaimer = True

    # Just passing a message
    if 'msg_str' in request.session:
        msg_str = request.session['msg_str']
        request.session.pop('msg_str')

    return render(request, template, {
        'step': step,
        'msg_str': msg_str,
        'forms': step_forms,
        'disclaimer': disclaimer,
        'default_email': settings.DEFAULT_FROM_EMAIL,
        'run_type': run_type,
        'app': app_name,
    })


@login_required(login_url='/login/')
def step_domain(request):
    template, step, last_step, msg_str = templates[1]['path'], templates[1]['step'], 0, None
    step_forms, errors, msg = [], [], None
    step_name = 'step' + str(step)
    grid_info, grid_table, bbox, bbox_types, boundaries, boundary_types, bathymetry = None, None, [], [], [], [], []

    # If no steps - redirect
    if 'last_step' not in request.session:
        return redirect(templates[0]['name'])

    # Return Global Bounding Box only
    # Commented on 26/09/2018 - Global BBox no longer used
    #bbox_queryset = front_models.BBox.objects.filter(bbox_type=front_models.BBox.BOXTYPE_GLOBAL)
    #if bbox_queryset:
    #    bbox = serialize('geojson', bbox_queryset)
    #    bbox_types = [{'type': item.bbox_type, 'label': str(dict(front_models.BBox.BOXTYPE)[item.bbox_type]), 'color': item.color}
    #                  for item in bbox_queryset]

    max_nodes = request.user.profile.node_maxnr
    max_bytes_size = calc_maxfilesize(max_nodes)

    run_type = 'basic2d'
    if 'run_type' in request.session['step1']:
        run_type = request.session['step1']['run_type']

    if step_name in request.session:
        boundaries = request.session[step_name]['boundaries']['geojson']
        boundary_types = request.session[step_name]['boundaries']['legend']
        if 'bathymetry' in request.session[step_name]:
            bathymetry = request.session[step_name]['bathymetry']

        selcrs = request.session[step_name]['crs']
        try:
            selcrs = front_models.CRS.objects.get(pk=selcrs).name
        except Exception:
            pass

        # Validate if Boundaries Extent is inside Global BBox and Open boundaries is inside Oceanic BBox
        # Removed restriction on 26/09/2018
        #boundariesinbbox, msg = validate_bboxes(boundaries, selcrs)
        #if not boundariesinbbox:
        #    errors.append(msg)

        # Validate if Outer Boundaries are closed
        outerboundariesclosed, msg = validate_outerboundaries(boundaries)
        if not outerboundariesclosed:
            errors.append(msg)

        if 'grid_info' in request.session[step_name]:
            grid_info = request.session[step_name]['grid_info']

    else:
        data = DataInputForm(run_type=run_type)
        step_forms.append(data)

    if grid_info:
        grid_table = GridTableSummary([grid_info])

    # Just passing a message
    if 'msg_str' in request.session:
        msg_str = request.session['msg_str']
        request.session.pop('msg_str')

    return render(request, template, {
        'step': step,
        'msg_str': msg_str,
        'forms': step_forms,
        'errors': errors,
        'grid_info': grid_table,
        'bbox': bbox,
        'bbox_types': bbox_types,
        'boundaries': boundaries,
        'boundary_types': boundary_types,
        'bathymetry': bathymetry,
        'max_nodes': max_nodes,
        'max_bytes_size': round(max_bytes_size / (1024 * 1024)),
        'run_type': run_type,
        'app': app_name,
    })


@login_required(login_url='/login/')
def step_front(request):
    template, step, last_step, msg_str = templates[2]['path'], templates[2]['step'], 0, None
    step_forms, errors, bbox, bbox_types, boundaries, boundary_types, forcings_table, forcings = [], [], [], [], [], [], None, []
    step_name = 'step' + str(step)

    # If no steps - redirect
    if 'last_step' not in request.session:
        return redirect(templates[0]['name'])
    else:
        last_step = request.session['last_step']

        # Not quite at this step yet - return to step immediately next to last step
        if last_step < step - 1:
            return redirect(templates[last_step]['name'])

        runperiod_pk = request.session['step1']['run_period_pk']

        # Get simulation run type
        run_type = 'basic2d'
        if 'run_type' in request.session['step1']:
            run_type = request.session['step1']['run_type']

        # Return Active Oceanic and Atmosphere Forcing's Bounding Boxes only
        if 'waves' in run_type:
            bbox_queryset = front_models.BBox.objects.filter(bbox_type__in=[front_models.BBox.BOXTYPE_OCEANIC,
                                                                            front_models.BBox.BOXTYPE_ATMOSPHERE,
                                                                            front_models.BBox.BOXTYPE_WAVES]).filter(forcing_source__active=True)
        else:
            bbox_queryset = front_models.BBox.objects.filter(bbox_type__in=[front_models.BBox.BOXTYPE_OCEANIC,
                                                                        front_models.BBox.BOXTYPE_ATMOSPHERE]).filter(forcing_source__active=True)
        if bbox_queryset:
            # TODO: stabilize this workaround - condition models to selected runperiod
            try:
                runperiod = dm_models.ModelVersionRunPeriod.objects.get(id=runperiod_pk)
                if runperiod.run_period == 72:
                    bbox_queryset = bbox_queryset.exclude(forcing_source__parent__reference='prism2017')
            except Exception:
                pass

            bbox = serialize('geojson', bbox_queryset)
            bbox_types = [
                {'forcing': item.forcing_source.pk, 'label': item.forcing_source.parent_reference(), 'color': item.color} for item in bbox_queryset]

        # Get only Open Boundaries
        bids = []
        boundaries_all = json.loads(request.session['step2']['boundaries']['geojson'])
        for obj in boundaries_all['features']:
            if obj['properties']['type'] == 'Open':
                bids.append(obj['properties']['code'])
                boundaries.append(obj)
        boundary_types = [{'type': 'Open', 'label': 'Open', 'color': 'blue'}]

        # Commented on 26/09/2018 - Team decided to remove this restriction
        #if len(boundaries) == 0:
        #    errors.append(_('Não existem fronteiras abertas!'))

        if request.method == 'POST':
            # Preparing Atm Model form
            atmmodelsChoice = ForcingAtmModelForm(request.POST, run_type=run_type)
            step_forms.append(atmmodelsChoice)

            if len(boundaries) > 0:
                # Preparing Ocean Model form
                oceanmodelsChoice = ForcingOceanModelForm(request.POST, runperiod_pk=runperiod_pk, run_type=run_type)
                step_forms.append(oceanmodelsChoice)

                # Preparing Forcing type choice form
                tableChoice = ForcingChoiceForm(request.POST, run_type=run_type, bids=bids)
                step_forms.append(tableChoice)

            # Validate form to move to next step
            valid, msg = form_validation(request, step)
            if valid:
                # All went well - update LAST STEP
                if last_step < step:
                    request.session['last_step'] = step
                # Goto next step

wizard/templates/wizard/header.html
{% load i18n %}

{% block content %}

    <div class="jumbotron">
        <div class="row">
            <div class="col-xs-7">
                <h1>
                    {% trans "Assistente de Configuração" %}
                    <span id="deploy_id" class="label label-info">{% if request.session.deploy_id.0 %}ID:{{ request.session.deploy_id.0 }}{% endif %}{% if request.session.deploy_id.1 %}:{{ request.session.deploy_id.1 }}{% endif %}</span>
                </h1>
            </div>
            <div class="col-xs-5 text-right">
                <button id="btn_new" type="button" class="btn btn-default" data-toggle="tooltip" data-placement="bottom" title="{% trans 'Recomeçar, limpa todo o Assistente de Configuração' %}" {% if not request.session.last_step %} disabled="" {% endif %}>
                    <span class="glyphicon glyphicon-plus-sign"></span> <strong>{% trans "Novo Sistema" %}</strong>
                </button>
                <button id="btn_save" type="button" class="btn btn-primary" data-toggle="tooltip" data-placement="bottom" title="{% trans 'Guardar passos concluidos' %}" {% if not request.session.last_step or errors %} disabled="" {% endif %}>
                    <span class="glyphicon glyphicon-floppy-disk"></span> <strong>{% trans "Guardar" %}</strong>
                </button>
            </div>
        </div>

        {% include "wizard/steps.html" %}

    </div>
    {% include "front/modal/processing.html" %}

    <script type="text/javascript">
        // Tips global var
        var intro = introJs();

        var dname = null;
        // Save wizard state sessions from client-side
        $('#btn_save').click(function(e){
            {% if not request.session.deploy_id %}
            $("#inputname_form_error").html('');
            $('#divModal_inputname').modal('show');
            {% else %}
            // First disable button to prevent multiple calls
            $(this).attr('disabled', '');
            // Add some animation
            var btn = $(this);
            var btnlbl = btn.html();
            btn.html('<span class="glyphicon glyphicon-repeat spin"></span> ' + btnlbl);

            // Action on server-side
            $.ajax({
                type: 'GET',
                url: '{% url 'wizard:save_steps' step=0 %}',
                success: function(data) {
                    if (data["msg"]) {
                        $('#msg_str').html(data["msg"]);
                        if (data["deploy_id"]) {
                            $('#deploy_id').html(data["deploy_id"]);
                            {% if step == 7 %}
                            $('a.btn-default').each(function(){
                                $(this).attr('href', this.href.replace('/0/', '/' + data.deploy_id.replace('ID:', '') + '/'));
                            });
                            {% endif %}
                        }
                        $('#divModal_msg').modal('show');
                    }

                    // Reset button
                    btn.removeAttr('disabled');
                    btn.html(btnlbl);
                },
                error: function(e, x, r) {
                    console.log(r + ' - ' + e);
                    $('#msg_str').html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');
                    $('#divModal_msg').modal('show');

                    // Reset button
                    btn.removeAttr('disabled');
                    btn.html(btnlbl);
                }
            });
            e.preventDefault();
            {% endif %}
        });

        // On Document Ready
        $(function(){
            // Render Steps state
            var nrsteps = $(".bs-wizard-step").length + 1;

            for (i=1; i<nrsteps; i++) {
                if (i==step) {
                    $('#step'+i).removeClass('disabled');
                    $('#step'+i).addClass('active');
                    if (i<=last_step) $('#step'+i).addClass('completed');
                } else if (i<step || i<=last_step) {
                    $('#step'+i).removeClass('disabled');
                    $('#step'+i).addClass('complete');
                }
            }

            //activate next step
            $('#step'+(last_step+1)).removeClass('disabled');
            if (step < last_step+1) $('#step'+(last_step+1)).addClass('enabled');

            // Tips Settings
            {% if disclaimer %}
            intro.setOptions({
                steps: [{
                    intro: "{% trans 'Bem-vindo! Como é a sua primeira sessão siga este Assistente de Utilização' %}"
                  }, {
                    element: '#tips_btn',
                    intro: "{% trans 'Pode ativar estas ajudas, a partir deste botão, em qualquer momento e em qualquer passo' %}"
                  }, {
                    element: '#help_btn',
                    intro: "{% trans 'Todos os passos têm também este botão que expande um painel com informação adicional' %}"
                  }, {
                    element: '.bs-wizard',
                    intro: "{% trans 'A partir deste painel sabe sempre em que passo está e os que já concluiu, pode também usá-lo como menu de navegação' %}"
                  }, {
                    element: '#btn_new',
                    intro: "{% trans 'A partir do 2º passo pode recomeçar de novo, este botão limpa todo o Assistente de Configuração' %}"
                  }, {
                    element: '#btn_save',
                    intro: "{% trans 'A partir deste botão os passos concluidos são guardados, pode depois aceder ao Sistema a partir da página de Sistemas de Previsão' %}"
                  }, {
                    element: '#form_div',
                    intro: "{% trans 'Neste passo começe por preencher o formulário' %}"
                  }, {
                    element: '#btn_submit',
                    intro: "{% trans 'E prima o botão para continuar' %}"
                  }
                ],
                "nextLabel": " » ",
                "prevLabel": " « ",
                "skipLabel": " {% trans 'Fechar' %} ",
                "doneLabel": " {% trans 'Terminado' %} ",
                "disableInteraction": true,
                "tooltipPosition": "top"
            });
            {% else %}
            intro.setOptions({
                "nextLabel": " » ",
                "prevLabel": " « ",
                "skipLabel": " {% trans 'Fechar' %} ",
                "doneLabel": " {% trans 'Terminado' %} ",
                "disableInteraction": true,
                "tooltipPosition": "top"
            });
            {% endif %}

            $('#btn_name').click(function(e){
                // Validate form
                var name = $("input[name='inputname']").val();
                dname = name;   //save in global just in case we need it later
                if (!name) {
                    $("#inputname_form_error").html('{% trans "O campo é obrigatório." %}');
                } else {
                    // First disable button to prevent multiple calls
                    $(this).attr('disabled', '');
                    // Add some animation
                    var btn = $(this);
                    var btnlbl = btn.html();
                    btn.html('<span class="glyphicon glyphicon-repeat spin"></span> ' + btnlbl);

                    $.ajax({
                        type: 'POST',
                        url: '{% url 'wizard:save_steps' step=0 %}',
                        data: $('#inputname_form').serialize(),
                        success: function(data) {
                            $('#divModal_inputname').modal('hide');
                            $('#msg_str').html(data["msg"]);

                            if (data["deploy_id"]) {
                                $('#deploy_id').html(data["deploy_id"]);
                                {% if step == 7 %}
                                $('#id_name').val(dname);
                                $('a.btn-default').each(function(){
                                    $(this).attr('href', this.href.replace('/0/', '/' + data["deploy_id"].replace('ID:', '') + '/'));
                                });
                                {% endif %}
                            }
                            $('#divModal_msg').modal('show');

                            // Reset button
                            btn.removeAttr('disabled');
                            btn.html(btnlbl);
                        },
                        error: function(e, x, r) {
                            console.log(r + ' - ' + e);
                            $("#inputname_form_error").html('{% trans "Ocorreu um erro! Por favor tente mais tarde." %}');

                            // Reset button
                            btn.removeAttr('disabled');
                            btn.html(btnlbl);
                        }
                    });
                }
                e.preventDefault();
            });

            // Button redirect page to previous step without validation
            $('#btn_prev').click(function(e){
                e.preventDefault();
                if (step != 0) window.location.href = '/wizard/step' + (step-1);
            });

            // Button redirect page to next step without validation
            $('#btn_next').click(function(e){
                e.preventDefault();
                if (step != 0) window.location.href = '/wizard/step' + (step+1);
            });

            // Button to restart step
            $('#btn_restart').click(function(e){
                e.preventDefault();
                if (step != 0) {
                    $('#exec_btn').on('click', function () {
                        window.location.href = '/wizard/step' + step + '/restart';
                    });

                    var message = '{% trans "Esta ação recomeça o Assistente de Configuração a partir deste passo, limpando-o bem como os posteriores. Se deseja manter a configuração atual prima Não." %}';
                    $('#cfm_tit').html('{% trans "Recomeçar" %}');
                    $('#cfm_str').html(message);               // Set message according to action
                    $('#divModal_confirm').modal();            // Show Confirm Modal
                 }
            });

            // New Deployment action
            $('#btn_new').click(function(e){
                if (last_step > 0) {
                    $('#exec_btn').on('click', function () {
                        // Validate server-side if user can create new deploy
                        //newdeploy("{% url 'front:new_deploy' %}", "{% url 'wizard:step1_restart' %}");
                        window.location.href = "{% url 'wizard:step1_restart' %}";
                    });

                    var message = '{% trans "O Assistente de Configuração será reiniciado. Se fez alterações à configuração atual e deseja mantê-las prima Não e guarde primeiro." %}';
                    $('#cfm_tit').html('{% trans "Recomeçar" %}');
                    $('#cfm_str').html(message);               // Set message according to action
                    $('#divModal_confirm').modal();            // Show Confirm Modal
                } else {
                    // Validate server-side if user can create new deploy
                    //newdeploy("{% url 'front:new_deploy' %}", "{% url 'wizard:step1_restart' %}");
                    window.location.href = "{% url 'wizard:step1_restart' %}";
                }
                e.preventDefault();
            });
        });
    </script>

{% endblock content %}

wizard/templates/wizard/steps.html
{% load i18n %}

{% block content %}

    <div class="row bs-wizard">
        <div id="step1" class="col-xs-1 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 1</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated %}
          <a href="{% url 'wizard:step1' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Modelo" %}</div>
        </div>

        <div id="step2" class="col-xs-2 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 2</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 1 %}
          <a href="{% url 'wizard:step2' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Domínio" %}</div>
        </div>

        <div id="step3" class="col-xs-2 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 3</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 2 %}
          <a href="{% url 'wizard:step3' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Fronteiras" %}</div>
        </div>

        <div id="step4" class="col-xs-2 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 4</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 3 %}
          <a href="{% url 'wizard:step4' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Estações" %}</div>
        </div>

        <div id="step5" class="col-xs-2 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 5</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 4 %}
          <a href="{% url 'wizard:step5' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Parâmetros" %}</div>
        </div>

        <div id="step6" class="col-xs-2 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 6</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 5 %}
          <a href="{% url 'wizard:step6' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Dados adicionais" %}</div>
        </div>

        <div id="step7" class="col-xs-1 bs-wizard-step">
          <div class="text-center bs-wizard-stepnum">{% trans "Passo" %} 7</div>
          <div class="progress"><div class="progress-bar"></div></div>
          {% if user.is_authenticated and request.session.last_step >= 6 %}
          <a href="{% url 'wizard:step7' %}" class="bs-wizard-dot"></a>
          {% else %}
          <span class="bs-wizard-dot"></span>
          {% endif %}
          <div class="bs-wizard-info text-center">{% trans "Submissão" %}</div>
        </div>
    </div>

{% endblock content %}